## proc do tworzenia grafu...
#
namespace eval G {}; # wszystkie proc w ns G

# proc ogolnego przeznaczenia
#
proc G::ciag {i1 i2} {
  for {set i $i1} {$i<=$i2} {incr i} {lappend _ $i}
  return $_
}
proc G::dolaczOdPrzodu {li_ w} {
  upvar $li_ li; set li [linsert $li 0 $w]
  return {}
}
proc G::listaIstnieje li_ {
  upvar $li_ li
  if {![info exists li]} {set li [list]}
  return {}
}

# proc do tworzenia grafu
# + zm. glob: liczbaWierz, sasiedzi
#
proc G::kraw {v1 v2} {
  global liczbaWierz sasiedzi
  if {![info exists liczbaWierz]} {set liczbaWierz 0}
  if {$liczbaWierz<=$v1} {set liczbaWierz [expr {$v1+1}]}
  if {$liczbaWierz<=$v2} {set liczbaWierz [expr {$v2+1}]}
  listaIstnieje sasiedzi($v1)
  listaIstnieje sasiedzi($v2)
  dolaczOdPrzodu sasiedzi($v1) $v2
  lappend sasiedzi($v2) $v1
  return {}
}
proc G::sciezka {zb_wierz} {
  set len [llength $zb_wierz]
  for {set i 0} {$i<$len-1} {incr i} { 
	kraw [lindex $zb_wierz $i] [lindex $zb_wierz [expr {$i+1}]]
  }
  return {}
}
proc G::sciezka2 {v1 vk} {
  sciezka [ciag $v1 $vk]
}
proc G::gwiazda {zb_wierz v0} { # v0 - centrum, zb_wierz - promienie
  foreach v $zb_wierz { kraw $v $v0 }
  return {}
}
proc G::gwiazda2 {v1 vk v0} { # v0 - centrum
  gwiazda [ciag $v1 $vk] $v0
}
proc G::pokazGraf {} {
  global liczbaWierz sasiedzi
  set _ ""
  for {set i 0} {$i<$liczbaWierz} {incr i} {
	listaIstnieje sasiedzi($i)
    append _ "$i: $sasiedzi($i)\n"
  }
  return $_
}

proc G::dwudzielnyPelny {zb1 zb2} {
  foreach v1 $zb1 {
    foreach v2 $zb2 {
	  kraw $v1 $v2
	}
  }
  return {}
}
proc G::dwudzielnyPelny2 {v1 vk w1 wl} {
  dwudzielnyPelny [ciag $v1 $vk] [ciag $w1 $wl]
}


# rysujGraf przy pomocy graphviz/dot
# + tworzy 1 okno toplevel .t z canvasem .t.c
# + zwraca tablice glob. tc_nodes i tc_edges
# + oznaczenia elem canvasa .t.c:
#    0$tc_node(X) - tekst (id wierz)
#    1$tc_node(X) - owal
#    0$tc_edge(X->Y) - text kraw
#    0b$tc_edge(X->Y) - tekst beltu (nr pol)
#    0g$tc_edge(X->Y) - tekst grotu (nr pol)
#    1$tc_edge(X->Y) - linia/strzalka kraw
#
proc G::rysujGraf {args} {
  set opt(-zero) 0; # strzalka na pol nr 0
  set opt(-opcje) ""; # opcje grafowe w j. dot
  array set opt $args
  # tworzymy nowe okno .t.c ...
  if {[winfo exists .t.c]} { .t.c delete all } {
    destroy .t; toplevel .t; canvas .t.c 
    wm title .t "okno G::rysujGraf"
    wm geom .t 500x500 
    pack .t.c -fill both -expand 1
    .t.c conf -bg pink
    # obsluga zdarzen .t.c ...
    set ::G::__bb 0
    bind .t.c <Button-1> {
      set ::G::__bb 1; set ::G::__xx %x; set ::G::__yy %y
    }
    bind .t.c <ButtonRelease-1> {set ::G::__bb 0}
    bind .t.c <Motion> {
      if {!$::G::__bb} continue
      .t.c move all [expr %x-$::G::__xx] [expr %y-$::G::__yy]
      set ::G::__xx %x; set ::G::__yy %y
    }
    bind .t.c <Button-3> {.t.c scale all %x %y .8 .8}
    bind .t.c <Control-Button-3> {.t.c scale all %x %y 1.25 1.25}
      # + B-3 i Ctrl-B-3
    bind .t.c <Button-4> {.t.c scale all %x %y .8 .8}    
    bind .t.c <Button-5> {.t.c scale all %x %y 1.25 1.25}
      # + guzik myszy pod unixem (pod win trzeba uzyc MouseWheel ?!)
  }
  # budujemy kod w j. dot...
  global liczbaWierz sasiedzi
  set kraw ""
  for {set i 0} {$i<$liczbaWierz} {incr i} {
    set ss $sasiedzi($i); set ss_len [llength $ss]
    for {set ii 0} {$ii<$ss_len} {incr ii} {
      set j [lindex $ss $ii]
      if {$j>$i} { if {$opt(-zero)} { 
        set ii2 [__nrPol $i $j]
        if {$ii==0} {set ah vee} {set ah none}
        if {$ii2==0} {set at vee} {set at none}
        append kraw "$i -> $j \[
          headlabel=\" \", taillabel=\" \", 
          arrowhead=$ah, arrowtail=$at, 
          label=\" \"
          \]\n"
      } {
        set ii2 [__nrPol $i $j]
        append kraw "$i -> $j \[
          headlabel=\"$ii2\", taillabel=\"$ii\", 
          arrowhead=none, arrowtail=none,
          label=\" \"
          \]\n"
      }}
    }
  }
  set kod [__dot2tk [string map [list @kraw@ $kraw @opcje@ $opt(-opcje)] {
    digraph mojgraf1 { 
      node [width=0.8, height=0.3]
      @opcje@      
      @kraw@
    }
  }]]
  set kod [string map {".c " ".t.c " ".c_" ".t.c_"} $kod]
  # wykonujemy kod w j. dot...
  eval $kod
  # tworzymy glob. tabl. tc_node i tc_edge
  global tc_node tc_edge
  catch {unset tc_node}; catch {unset tc_edge}
  array set tc_node ${.t.c_nodes}; array set tc_edge ${.t.c_edges}
  
  # naprawa tag-ow na kraw...
  foreach kraw [array name tc_edge] {
    set x [lsort -integer [.t.c find withtag 0$tc_edge($kraw)]]
    if {[llength $x]!=3} continue
    set t1 [.t.c itemcget [lindex $x 1] -tag]
    set tt1 "[string index $t1 0]g[string range $t1 1 end]"
    set t2 [.t.c itemcget [lindex $x 2] -tag]
    set tt2 "[string index $t2 0]b[string range $t2 1 end]"
    #puts "dbg: x=$x"
    .t.c itemconfig [lindex $x 1] -tag $tt1
    .t.c itemconfig [lindex $x 2] -tag $tt2
  }

  return {}
}
proc G::__nrPol {id id2} { # pozycja id w $sasiedzi(id2)
  global sasiedzi
  return [lsearch $sasiedzi($id2) $id]
}
package re http
proc G::__dot2tk kod {
  # trzeba dodac jakies zabezpieczenie przed naduzyciem!!!
  set q [http::formatQuery dot11232 $kod]
  set h [http::geturl http://mhanckow.vm.wmi.amu.edu.pl:20002/acs01d2 -query $q]
  set r [http::data $h]
  http::cleanup $h
  set r
}


# proc pomocnicze tc_*
# + tc_edge_nrPol {id nrPol}
#   zwraca tag napisu z nr pol
# + tc_edge_srodek {id nrPol}
#   zwraca tag napisu srodkowego kraw
# + tc_strzalka_kolor {kraw kolor}
#   kolorowanie strzalek w trybie "-zero 1"
#
proc tc_edge_nrPol {id nrPol} {
  global sasiedzi tc_edge
  set id2 [lindex $sasiedzi($id) $nrPol]
  if {$id2>$id} {
    return "0b$tc_edge($id->$id2)"
  } else { # $id2<$id
    return "0g$tc_edge($id2->$id)"
  }
}
proc tc_edge_srodek {id nrPol} {
  global sasiedzi tc_edge
  set id2 [lindex $sasiedzi($id) $nrPol]
  if {$id2>$id} {
    return "0$tc_edge($id->$id2)"
  } else { # $id2<$id
    return "0$tc_edge($id2->$id)"
  }
}
proc tc_strzalka_kolor {kraw kolor} {
  global tc_edge
  set x [lsort -integer [.t.c find withtag 1$tc_edge($kraw)]]
  .t.c itemconfig [lindex $x 0] -fill $kolor
  .t.c itemconfig [lindex $x 1] -outline $kolor -fill $kolor
  if {[llength $x]==3} {
    .t.c itemconfig [lindex $x 2] -outline $kolor -fill $kolor
  }
}





if 0 { # test

set liczbaWierz 0
array unset sasiedzi
G::sciezka2 0 2
G::sciezka2 3 5
G::sciezka2 6 8
G::gwiazda {2 5 8} 9
G::gwiazda2 10 20 9
G::gwiazda2 10 20 21
G::rysujGraf -zero 1
#G::rysujGraf
.t.c itemconfig 1$tc_edge(2->9) -width 1
.t.c itemconfig 1$tc_node(9) -fill yellow
.t.c itemconfig 1$tc_node(13) -fill pink

}

