wm withdraw .; wm geo .output 339x610+641+138; wm geo .konsola 560x622+993+134; # Morasko, tcl8.6

source symul_lib.tcl

# network definition:
set verticesNum 5
set neighbors(0) {4 1}
set neighbors(1) {0 2}
set neighbors(2) {1 3}
set neighbors(3) {2 4}
set neighbors(4) {3 0}

fiber create $verticesNum run

fiber_iterate {
# main program of each vertex (proc run)
# + this is the Leader Election algoirithm using O(n^2) messages
proc run {} {
  global id run msg id_rand
  
  send 1 $id_rand
  fiber yield; # end of a round

  while {$run} {
    if {$msg(0)!=""} {
      set x [recv 0]
      if {$x>$id_rand} {send 1 $x}
      if {$x==$id_rand} {_puts "$id ------> I am a leader !!!"}
    }
    fiber yield
  }
}
}

Initialization; # it must be called !


proc visualisation {} {
  _puts "--- $::round ---"; incr ::round
  fiber_iterate {_puts "$id, $id_rand: $msg(0), $msg(1)"}
}

# ... you can run everything to this place .....................................

_puts ---; fiber_iterate {_puts "$id, $id_rand"}
  # + shows id and id_rand of each vertex

set round 0; set msgCounter 0; set_run 0; fiber yield; set_run 1; fiber restart
  # + restart of the simulation

#fiber_iterate {set id_rand [expr round(rand()*10000)]}
  # + you can change id_rand

fiber error; # debugger
  #% {} {} {} {} {}

fiber yield; round; visualisation; set msgCounter; # run a single round...












exit